(ns clojureDemo.VisionReader
  (:gen-class
   :implements [connections.WiredBox]
   :methods [ [process [Object] void] [setFile [Object] void] ]
   :post-init register))

(import '(davidNackoul PlotUnitMatchAlgorithm StoryGraph PlotUnit))
(import '(bridge.reps.things Sequence Thing))


(defn -setFile
  [this file]
  (println "file is " file))

(defn -register
   "equivalent to Connections.getPorts(this).addSignalProcessor(\"process\"); in Java"
   [this]
   (println "ClojureBox  (register) : Register is run 
    only when the object is created, as if it were in every constructor.")
   (. (connections.Connections/getPorts this) addSignalProcessor "process"))

(defn -process [ _ _ ]
  (println "ClojureBox (process) :  This is a LISP function, 
   being called through Java, through the wiredBox metaphor."))

(defn -getName
  "the [_] means that  the function gets an explicit 'this'
    argument, just like python. In this case we don't care about it."
  [_]  "VisionReader")

 
